Index: calculatorview/perspectives/calculator/calculator.py
===================================================================
--- calculatorview/perspectives/calculator/calculator.py	(revision b0ab6cb339551bb39f126bcd9d13b2a9dd73ddbe)
+++ calculatorview/perspectives/calculator/calculator.py	(revision 44148f046582fd272d527676fd2fe859b68d6835)
@@ -145,6 +145,5 @@
         frame = KiessigWindow()
         frame.Show(True) 
-        event.Skip()
-       
+    
     def on_calculate_sld(self, event):
         """
@@ -154,6 +153,5 @@
         frame = SldWindow(base=self.parent)
         frame.Show(True) 
-        event.Skip()
-        
+       
     def on_calculate_slit_size(self, event):
         """
@@ -163,6 +161,5 @@
         frame = SlitLengthCalculatorWindow(parent=self.parent)    
         frame.Show(True)
-        event.Skip()
-        
+   
     def on_perspective(self, event):
         """
Index: calculatorview/perspectives/calculator/kiessig_calculator_panel.py
===================================================================
--- calculatorview/perspectives/calculator/kiessig_calculator_panel.py	(revision b0ab6cb339551bb39f126bcd9d13b2a9dd73ddbe)
+++ calculatorview/perspectives/calculator/kiessig_calculator_panel.py	(revision 44148f046582fd272d527676fd2fe859b68d6835)
@@ -185,7 +185,9 @@
      
 class KiessigWindow(wx.Frame):
-    def __init__(self, parent=None, title="Kiessig Thickness Calculator"):
-        wx.Frame.__init__(self, parent, title,
-                           size=(PANEL_WIDTH,PANEL_HEIGHT))
+    def __init__(self, parent=None, title="Kiessig Thickness Calculator",
+                  size=(PANEL_WIDTH,PANEL_HEIGHT), *args, **kwds):
+        kwds['title'] = title
+        kwds['size'] = size
+        wx.Frame.__init__(self, parent, *args, **kwds)
         self.parent = parent
         self.panel = KiessigThicknessCalculatorPanel(parent=self)
Index: calculatorview/perspectives/calculator/sld_panel.py
===================================================================
--- calculatorview/perspectives/calculator/sld_panel.py	(revision b0ab6cb339551bb39f126bcd9d13b2a9dd73ddbe)
+++ calculatorview/perspectives/calculator/sld_panel.py	(revision 44148f046582fd272d527676fd2fe859b68d6835)
@@ -46,8 +46,8 @@
     CENTER_PANE = True
     
-    def __init__(self, parent, base=None):
-        """
-        """
-        wx.Panel.__init__(self, parent)
+    def __init__(self, parent, base=None, *args, **kwds):
+        """
+        """
+        wx.Panel.__init__(self, parent, *args, **kwds)
         #Font size 
         self.SetWindowVariant(variant=FONT_VARIANT)
@@ -415,9 +415,11 @@
     """
     """
-    def __init__(self, parent=None, title="SLD Calculator", base=None):
-        """
-        """
-        wx.Frame.__init__(self, parent, title,
-                           size=(PANEL_SIZE, PANEL_SIZE))
+    def __init__(self, parent=None, title="SLD Calculator",
+                  base=None, size=(PANEL_SIZE, PANEL_SIZE), *args, **kwds):
+        """
+        """
+        kwds['title'] = title
+        kwds['size'] = size
+        wx.Frame.__init__(self, parent, *args, **kwds)
         """
         """
@@ -432,5 +434,5 @@
         """
         """
-        frame = SldWindow(None, -1, 'SLD Calculator')    
+        frame = SldWindow(None, title='SLD Calculator')    
         frame.Show(True)
         self.SetTopWindow(frame)
Index: calculatorview/perspectives/calculator/slit_length_calculator_panel.py
===================================================================
--- calculatorview/perspectives/calculator/slit_length_calculator_panel.py	(revision b0ab6cb339551bb39f126bcd9d13b2a9dd73ddbe)
+++ calculatorview/perspectives/calculator/slit_length_calculator_panel.py	(revision 44148f046582fd272d527676fd2fe859b68d6835)
@@ -238,9 +238,11 @@
     """
     """
-    def __init__(self, parent=None, title="Slit Size Calculator"):
-        """
-        """
-        wx.Frame.__init__(self, parent, title,
-                           size=(PANEL_WIDTH,PANEL_HEIGHT))
+    def __init__(self, parent=None, title="Slit Size Calculator",
+                size=(PANEL_WIDTH,PANEL_HEIGHT), *args, **kwds):
+        """
+        """
+        kwds['size']= size
+        kwds['title']= title
+        wx.Frame.__init__(self, parent, *args, **kwds)
         self.parent = parent
         self.panel = SlitLengthCalculatorPanel(parent=self)