Index: build_tools/jenkins_linux_build_ver02.sh
===================================================================
--- build_tools/jenkins_linux_build_ver02.sh	(revision 22c1f1c4c3d370b610d2b0d80ad846f505e67a9a)
+++ build_tools/jenkins_linux_build_ver02.sh	(revision 22c1f1c4c3d370b610d2b0d80ad846f505e67a9a)
@@ -0,0 +1,54 @@
+#! /bin/sh
+
+# try to find reasonable settings, if not provided in the environment
+PYTHON=${PYTHON:-`which python`}
+EASY_INSTALL=${EASY_INSTALL:-`which easy_install`}
+PYLINT=${PYLINT:-`which pylint`}
+#BUILD_TOOLS_DIR=`dirname $0`
+#WORKSPACE=${WORKSPACE:-`readlink -f $BUILD_TOOLS_DIR/..`}
+# WORKSPACE top top level of source  
+
+
+cd $WORKSPACE
+
+cd $WORKSPACE/sasview
+
+if [ ! -d "utils" ]; then
+    mkdir utils
+fi
+
+rm -rf sasview-install
+mkdir sasview-install
+rm -rf dist
+rm -rf build
+
+
+export PYTHONPATH=$WORKSPACE/sasview/sasview-install:$WORKSPACE/sasview/utils:$PYTHONPATH
+
+
+"$EASY_INSTALL" -d "$WORKSPACE/sasview/utils" bumps==0.7.5.6
+"$EASY_INSTALL" -d "$WORKSPACE/sasview/utils" periodictable==1.3.0
+
+# CHECK_PACKAGES
+$PYTHON check_packages.py
+
+# BUILD_CODE
+$PYTHON setup.py build
+
+# TEST_CODE
+cd test
+$PYTHON utest_sasview.py
+cd ..
+
+# BUILD_DOCS
+$PYTHON setup.py docs
+
+# BUILD_EGG 
+$PYTHON setup.py bdist_egg --skip-build
+
+cd $WORKSPACE/sasview/dist
+#ln -s sasview*.egg sasview.egg || true
+$EASY_INSTALL -N -d ../sasview-install sasview*.egg
+
+cd $WORKSPACE
+
Index: build_tools/jenkins_linux_pylint_ver02.sh
===================================================================
--- build_tools/jenkins_linux_pylint_ver02.sh	(revision 98ae0baafdc1e905136808c8b29fb0f6a83b7cda)
+++ build_tools/jenkins_linux_pylint_ver02.sh	(revision 98ae0baafdc1e905136808c8b29fb0f6a83b7cda)
@@ -0,0 +1,19 @@
+#! /bin/sh
+set -x
+
+# try to find reasonable settings, if not provided in the environment
+PYTHON=${PYTHON:-`which python`}
+PYLINT=${PYLINT:-`which pylint`}
+#BUILD_TOOLS_DIR=`dirname $0`
+#WORKSPACE=${WORKSPACE:-`readlink -f $BUILD_TOOLS_DIR/..`}
+# WORKSPACE top level of source
+
+
+
+
+export PYTHONPATH=$WORKSPACE/sasview/sasview-install:$WORKSPACE/sasview/utils:$PYTHONPATH
+
+cd $WORKSPACE/sasview
+rm -f test/sasview.txt
+
+$PYLINT --rcfile "build_tools/pylint.rc" -f parseable sasview-install/sasview*.egg/sas sasview > test/sasview.txt
Index: src/sas/sasgui/guiframe/gui_manager.py
===================================================================
--- src/sas/sasgui/guiframe/gui_manager.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/guiframe/gui_manager.py	(revision 0d534de9f869910429443e7898a0b7ab65db05a7)
@@ -1290,5 +1290,5 @@
                         wx.EVT_MENU(self, id, tool[2])
             if self._tool_menu is not None:
-                self._menubar.Append(self._tool_menu, '&Tool')
+                self._menubar.Append(self._tool_menu, '&Tools')
 
     def _add_current_plugin_menu(self):
@@ -1321,12 +1321,12 @@
                 for (menu, name) in menu_list:
                     if self._applications_menu_pos == -1:
-                        # Find the Help position and insert just before it if possible
-                        help_pos = self._menubar.FindMenu("Help")
-                        if help_pos == -1:
+                        # Find the Analysis position and insert just after it if possible
+                        analysis_pos = self._menubar.FindMenu("Analysis")
+                        if analysis_pos == -1:
                             self._menubar.Append(menu, name)
                             self._applications_menu_pos = -1
                         else:
-                            self._menubar.Insert(help_pos-1, menu, name)
-                            self._applications_menu_pos = help_pos - 1
+                            self._menubar.Insert(analysis_pos+1, menu, name)
+                            self._applications_menu_pos = analysis_pos + 1
                     else:
                         self._menubar.Insert(self._applications_menu_pos, menu, name)
@@ -1492,5 +1492,15 @@
             if not plug_data_count or not plug_no_data_count:
                 self._applications_menu.RemoveItem(separator)
-            self._menubar.Append(self._applications_menu, '&Analysis')
+            #Windows introduces a "Window" menu item during the layout process
+            #somehow.  We want it to be next to the last item with Help as
+            #last. However Analysis gets stuck after Window in normal ordering
+            #so force it to be next after the Tools menu item.  Should we add
+            #another menu item will need to check if this is still where we 
+            #want Analysis.  This is NOT an issue on the Mac which does not
+            #have the extra Window menu item.
+            #      March 2016 Code Camp  -- PDB 
+            Tools_pos = self._menubar.FindMenu("Tools")
+            self._menubar.Insert(Tools_pos+1,self._applications_menu,
+                                 '&Analysis')
             self._check_applications_menu()
 