Index: sansview/perspectives/fitting/basepage.py
===================================================================
--- sansview/perspectives/fitting/basepage.py	(revision 998b6b89201a7cd6c504d77d16ac2274585ad70d)
+++ sansview/perspectives/fitting/basepage.py	(revision 60132ef18e274730daf212156c736dd44e98affe)
@@ -1,4 +1,4 @@
 
-import sys
+import sys, os
 import wx
 import numpy
@@ -57,4 +57,5 @@
         ## list of orientation parameters
         self.orientation_params=[]
+        self.orientation_params_disp=[]
         if self.model !=None:
             self.disp_list= self.model.getDispParamList()
@@ -76,5 +77,6 @@
         self.saved_states={}
         self.slicerpop = wx.Menu()
-        
+        ## Default locations
+        self._default_save_location = os.getcwd()     
         ## save initial state on context menu
         self.onSave(event=None)
@@ -263,5 +265,8 @@
                         self.disp_cb_dict[p].SetValue(False)
                         return
-                    
+                    try:
+                        self._default_save_location = os.path.dirname(path)
+                    except:
+                        pass 
                     try:
                         values,weights = self.read_file(path)
@@ -289,5 +294,5 @@
                     #TODO: refactor model to clean this up?
                     self._disp_obj_dict[p] = disp_model
-                    
+                    print "dispersity------>",p
                     # Set the new model as the dispersion object for the selected parameter
                     self.model.set_dispersion(p, disp_model)
@@ -432,5 +437,5 @@
         if hasattr(self,"cb1"):
             self.state.cb1= self.cb1.GetValue()
-            print "save current state ",self.state.cb1
+           
         if hasattr(self,"enable_disp"):
             self.state.enable_disp= self.enable_disp.GetValue()
@@ -447,4 +452,5 @@
         self.state.fittable_param=[]
         self.state.fixed_param=[]
+       
         self._copy_parameters_state(self.parameters, self.state.parameters)
         self._copy_parameters_state(self.fittable_param, self.state.fittable_param)
@@ -501,5 +507,6 @@
         """
         import os
-        dlg = wx.FileDialog(self, "Choose a weight file", os.getcwd(), "", "*.*", wx.OPEN)
+        dlg = wx.FileDialog(self, "Choose a weight file",
+                                self._default_save_location , "", "*.*", wx.OPEN)
         path = None
         if dlg.ShowModal() == wx.ID_OK:
@@ -1183,4 +1190,5 @@
             draw sizer with array dispersity  parameters
         """
+        self.orientation_params_disp=[]
         self.sizer4_4.Clear(True) 
         ix=0
Index: sansview/perspectives/fitting/fitpage.py
===================================================================
--- sansview/perspectives/fitting/fitpage.py	(revision 998b6b89201a7cd6c504d77d16ac2274585ad70d)
+++ sansview/perspectives/fitting/fitpage.py	(revision 60132ef18e274730daf212156c736dd44e98affe)
@@ -62,7 +62,7 @@
         for item in self.parameters:
             if event.type =="scipy":
-                item[5].SetValue(format_number(""))
+                item[5].SetValue("")
                 item[5].Hide()
-                item[6].SetValue(format_number(""))
+                item[6].SetValue("")
                 item[6].Hide()
                 self.text2_min.Hide()
@@ -200,5 +200,6 @@
         self.fittable_param=[]
         self.fixed_param=[]
-        self.orientation_params=[]
+        self.orientation_params_disp=[]
+       
         self.sizer4_4.Clear(True)
        
@@ -357,5 +358,5 @@
                         self.fittable_param.append([cb,name1,ctl1,text2,
                                                     ctl2, None, None,None])
-                        self.orientation_params.append([cb,name1,ctl1,text2,
+                        self.orientation_params_disp.append([cb,name1,ctl1,text2,
                                                     ctl2, None, None,None])
                     elif p=="npts":
@@ -377,5 +378,5 @@
                             self.fixed_param.append([None,name2, Tctl,None,None,
                                                       None, None,None])
-                            self.orientation_params.append([None,name2, Tctl,None,None,
+                            self.orientation_params_disp.append([None,name2, Tctl,None,None,
                                                       None, None,None])
                     elif p=="nsigmas":
@@ -399,5 +400,5 @@
                             self.fixed_param.append([None,name3, Tctl
                                                      ,None,None, None, None,None])    
-                            self.orientation_params.append([None,name3, Tctl
+                            self.orientation_params_disp.append([None,name3, Tctl
                                                      ,None,None, None, None,None]) 
                                   
@@ -711,4 +712,5 @@
                     item[0].SetValue(False)
                 self.param_toFit=[]
+                
         self.save_current_state()  
         
@@ -760,4 +762,5 @@
         self.fixed_param=[]
         self.orientation_params=[]
+        self.orientation_params_disp=[]
         
         if model ==None:
@@ -853,5 +856,5 @@
                 ix += 1
                 ctl3 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                ctl3.SetValue(format_number(param_min))
+                ctl3.SetValue(str(param_min))
                 ctl3.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
                 ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
@@ -866,5 +869,5 @@
                 ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
                 sizer.Add(ctl4, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                ctl4.SetValue(format_number(param_max))
+                ctl4.SetValue(str(param_max))
                 ctl4.Hide()
                 
@@ -934,5 +937,5 @@
                 ix += 1
                 ctl3 = wx.TextCtrl(self, -1, size=(_BOX_WIDTH/2,20), style=wx.TE_PROCESS_ENTER)
-                ctl3.SetValue(format_number(param_min))
+                ctl3.SetValue(param_min)
                 ctl3.Bind(wx.EVT_SET_FOCUS, self.onSetFocus)
                 ctl3.Bind(wx.EVT_KILL_FOCUS, self._onparamEnter)
@@ -951,5 +954,5 @@
                 ctl4.Bind(wx.EVT_TEXT_ENTER,self._onparamEnter)
                 sizer.Add(ctl4, (iy,ix),(1,1), wx.EXPAND|wx.ADJUST_MINSIZE, 0)
-                ctl4.SetValue(format_number(param_max))
+                ctl4.SetValue(param_max)
                 ctl4.Hide()
                 if self.data.__class__.__name__ =="Data2D":
Index: sansview/perspectives/fitting/modelpage.py
===================================================================
--- sansview/perspectives/fitting/modelpage.py	(revision aa1e9a720d489ebc02fab6aa8ee853ab73432202)
+++ sansview/perspectives/fitting/modelpage.py	(revision 60132ef18e274730daf212156c736dd44e98affe)
@@ -122,5 +122,5 @@
         self.fittable_param=[]
         self.fixed_param=[]
-        self.orientation_params=[]
+        self.orientation_params_disp=[]
        
         self.sizer4_4.Clear(True)
@@ -231,5 +231,5 @@
                         self.fittable_param.append([None,name1,ctl1,None,
                                                     None, None, None,None])
-                        self.orientation_params.append([None,name1,ctl1,None,
+                        self.orientation_params_disp.append([None,name1,ctl1,None,
                                                     None, None, None,None])
                     elif p=="npts":
@@ -247,5 +247,5 @@
                             self.fixed_param.append([None,name2, Tctl1,None,None,
                                                       None, None,None])
-                            self.orientation_params.append([None,name2, Tctl1,None,None,
+                            self.orientation_params_disp.append([None,name2, Tctl1,None,None,
                                                       None, None,None])
                     elif p=="nsigmas":
@@ -266,5 +266,5 @@
                             self.fixed_param.append([None,name3, Tctl2,
                                                      None,None, None, None,None])
-                            self.orientation_params.append([None,name3, Tctl2,
+                            self.orientation_params_disp.append([None,name3, Tctl2,
                                                      None,None, None, None,None])
             
@@ -291,7 +291,13 @@
             self._draw_model()
             self.model_view.Disable()
-            for item in self.orientation_params:
-                if item[2]!=None:
-                    item[2].Enable()
+          
+            if len(self.orientation_params)>0:
+                for item in self.orientation_params:
+                    if item[2]!=None:
+                        item[2].Enable()
+            if len(self.orientation_params_disp)>0:
+                 for item in self.orientation_params_disp:
+                    if item[2]!=None:
+                        item[2].Enable()
                 
     
@@ -417,5 +423,5 @@
         self.fixed_param=[]
         self.orientation_params=[]
-        
+        self.orientation_params_disp=[]
         if model ==None:
             ##no model avaiable to draw sizer 
Index: sansview/perspectives/fitting/pagestate.py
===================================================================
--- sansview/perspectives/fitting/pagestate.py	(revision 998b6b89201a7cd6c504d77d16ac2274585ad70d)
+++ sansview/perspectives/fitting/pagestate.py	(revision 60132ef18e274730daf212156c736dd44e98affe)
@@ -40,4 +40,6 @@
         #panel objects 
         self.fittable_param =[]
+        ## orientation parameters
+        self.orientation_params=[]
         #list of dispersion paramaters
         self.disp_list =[]
@@ -86,4 +88,5 @@
         obj.fixed_param = copy.deepcopy(self.fixed_param)
         obj.fittable_param = copy.deepcopy(self.fittable_param)
+        obj.orientation_params =  copy.deepcopy(self.orientation_params)
         obj.enable_disp = copy.deepcopy(self.enable_disp)
         obj.enable_smearer = copy.deepcopy(self.enable_smearer)